/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2019
* 
*        (as is).
*     .
********************************************************************************
*/




#ifndef __NEO_RELAY_BOARD_H
#define __NEO_RELAY_BOARD_H


#include "stm32f030x6.h"
#include "NeoRelay_UserConfig.h"



#define       MODE_PIN_1                   0
#define       MODE_PIN_2                   2
#define       MODE_GPIO                    GPIOA
#define       MODE_MASK                    ((1 << MODE_PIN_1) | (1 << MODE_PIN_2))

#define       DIN_PIN                      6
#define       DIN_GPIO                     GPIOA

#define       DOUT_PIN                     7
#define       DOUT_GPIO                    GPIOA

#define       STOP_KEY_PIN                 1
#define       STOP_KEY_GPIO                GPIOA

#define       LED_PIN                      5
#define       LED_GPIO                     GPIOA

#define       RELAY1_GPIO                  GPIOA
#define       RELAY1_PIN                   4
#define       RELAY2_GPIO                  GPIOF
#define       RELAY2_PIN                   0
#define       RELAY3_GPIO                  GPIOF
#define       RELAY3_PIN                   1
#define       RELAY4_GPIO                  GPIOB
#define       RELAY4_PIN                   1

#define       EXT_CTRL_GPIO                GPIOA
#define       RELAY1_EXT_CTRL_PIN          9
#define       RELAY2_EXT_CTRL_PIN          10
#define       RELAY3_EXT_CTRL_PIN          13
#define       RELAY4_EXT_CTRL_PIN          14

#define       RELAY1_GPIO_ENR              RCC_AHBENR_GPIOAEN
#define       RELAY2_3_GPIO_ENR            RCC_AHBENR_GPIOFEN
#define       RELAY4_GPIO_ENR              RCC_AHBENR_GPIOBEN

#define       MODE_KEY_HIGH                ((1 << MODE_PIN_1) | (1 << MODE_PIN_2))
#define       MODE_TRIGGER_HIGH            (1 << MODE_PIN_2)
#define       MODE_KEY_LOW                 (1 << MODE_PIN_1)
#define       MODE_TRIGGER_LOW             0

#define       DATA_AVAILABLE               (1 << 0)

#define       RELAY_NEO_DATA_ON            1
#define       RELAY_NEO_DATA_OFF           0

#define       PIN_STATE_LOW                0
#define       PIN_STATE_HIGH               1

#define       EXT_CTRL_IRQ_PRIORITY        1
#define       STOP_KEY_IRQ_PRIORITY        0
#define       LED_IRQ_PRIORITY             2
#define       EXT_CTRL_IRQ                 EXTI4_15_IRQn
#define       STOP_KEY_IRQ                 EXTI0_1_IRQn




void Module_Init();

void NeoResetEvent();

void RelayModeKeyHigh(uint8_t EnableNum, uint8_t EnableState);

void RelayModeTriggerHigh(uint8_t EnableNum, uint8_t EnableState);

void RelayModeTriggerLow(uint8_t EnableNum, uint8_t EnableState);

void RelayModeKeyLow(uint8_t EnableNum, uint8_t EnableState);

void RelayNeoData(uint8_t *Data);

void StopKeyPressed(void);


#endif //__NEO_RELAY_BOARD_H


