/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2019
* 
*        (as is).
*     .
********************************************************************************
*/



#ifndef __USER_CTRL_H
#define __USER_CTRL_H


#include "NeoRelay_board.h"


#define       CTRL_DEBOUNCE_TIME           50 //

//
#define       CTRL_SCAN_TIMER              TIM14
#define       CTRL_SCAN_TIMER_ENR          APB1ENR
#define       CTRL_SCAN_TIMER_CLK_EN       RCC_APB1ENR_TIM14EN
#define       CTRL_SCAN_TIMER_IRQ          TIM14_IRQn
#define       CTRL_SCAN_TIMER_PSC          239
#define       CTRL_SCAN_TIMER_ARR          199

#define       LEVEL_CHANGE_PENDING         (1 << 0)


typedef struct
{
  volatile uint8_t State;
  uint8_t          Pin;
  volatile uint8_t Level;
  volatile uint8_t Counter;
  
} CtrlType;


void CTRL_SCAN_TIMER_ISR(void);

void UserCtrl_Init(void (*EnableChangedCallback)(uint8_t, uint8_t));

uint8_t GetCtrlLevel(uint8_t CtrlNum);

void UserCtrlDisable();

void UserCtrlEnable();


#endif //__USER_CTRL_H


