/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2018
* 
*        (as is).
*     .
********************************************************************************
*/


#include "LED.h"



void LED_Init()
{
  LED_OFF();
  LED_GPIO->MODER |= (1 << (2 * LED_PIN));
    
  RCC->LED_TIMER_ENR |= LED_TIMER_CLK_EN;
  LED_TIMER->PSC = LED_TIMER_PSC;  
  LED_TIMER->ARR = LED_TIMER_ARR;
  LED_TIMER->DIER = TIM_DIER_UIE;
  NVIC_EnableIRQ(LED_TIMER_IRQ);
  NVIC_SetPriority(LED_TIMER_IRQ, LED_IRQ_PRIORITY);
}
//------------------------------------------------------------------------------
void LED_ON()
{
  LED_GPIO->ODR &= ~(1 << LED_PIN);
}
//------------------------------------------------------------------------------
void LED_OFF()
{
  LED_GPIO->ODR |= 1 << LED_PIN;
}
//------------------------------------------------------------------------------
void LED_StartBlink()
{
  LED_ON();
  
  LED_TIMER->CR1 |= TIM_CR1_CEN;
}
//------------------------------------------------------------------------------
void TIM16_IRQHandler()
{
  LED_TIMER->CR1 &= ~TIM_CR1_CEN;
  LED_TIMER->SR = 0;
  LED_TIMER->CNT = 0;
  
  LED_OFF();
}


